/*
  Test uLCD-32PTU.c 
  Dev 15.04.07

  Test code for 3.2" LCD Touch Screen Display with Adapter and microSD
  Card.  Product Part# 28080
  
  WARNING: The library accompanying this example code is an early draft
           from machine translated code that has only received minimal
           testing.  Community corrections and contributions are welcome.  
           
           Intended To-Do for those interested in contributing
            - Reduce code by putting each function in its own file
              and recompiling
            - Replace code that was machine translated from Spin with 
              Spin2Cpp tha with manually written code that relies the
              fdserial and simpletext libraries
            - Test/retest all functions and debug as needed   

  
  === SETUP ===
  
  Wiring
  
    uLCD   Jumper    Activity Board
    ----   ------    --------------
    +5V    Wire      5V
    GND    Wire      GND
    RX     220 Ohm   P15
    TX     220 Ohm   P14


  Prepare the LCD Display
  
    Follow Section 2.1 how to configure your Display Module as a Serial Slave
    http://www.4dsystems.com.au/productpages/PICASO/downloads/PICASO_serialcmdmanual_R_1_18.pdf
  

  Before you run this test application:
  
    Turn off Activity Board and uLCD power, remove MicroSD card, and 
    connect to your computer.
    
    Go to All Programs and run Graphics Composer from the 4D Workshop 4 
    IDE folder.
    
    Click the Add button to add images to the project.
    
    Click each file in the Entries list on the left, and then adjust where 
    you want it to appear in the screen on the right.
    
    Click the Build button (IC icon).
    
    In the Save As window, navigate to your MicroSD card, and set the 
    File name to img.
    
    The Build output window should show the MicroSD card's drive leter in 
    the folder field.  If not, click the ... button and select the MicroSD
    card.  Also make sure that the Build type is set to 4DGL - GCI- FAT
    Selected Folder.  Then, click OK.
    
    Eject your MicroSD from the OS, and put it back in the uLCD.
    
    Turn on Activity Board and uLCD power.
  
    Run this example code.  It uses 2 images.  If you only want to use one 
    image, comment these lines of code:
    
    response = 0;
    response = uLCD_Img_show(handle, 1);
    print("response = %x\n", response);
    pause(1000);
    
    If you want more images, make sure to increment the index for each image
    in the second parameter of this: 
      response = uLCD_Img_show(handle, 2); 
      response = uLCD_Img_show(handle, 3); 
    ...and so on, for each image that you Added to Graphics Composer.  
  

  To view the (not documented) API:
  
    Open ...\uLCD\libuLCD\libuLCD.side.
  
    Click the bottom-left Show Project Manager button.
  
    Click uLCD.h.
  
    Scroll to line 165, function list starts there. 
  
    IMPORTANT:
    Be careful not to use libuLCD.side and libuLCD.c as source code.  
    They are test harness for the library project.  We only opened it to 
    view the uLCD.h file.  For project source, open Test uLCD-32PTU.side 
    and use Save Project As to make a copy, and start experimenting with 
    that.
    
    The Library is a machine Spin2Cpp machine translation of this object.
    http://obex.parallax.com/object/802
*/

#include "simpletools.h"
#include "uLCD.h"

int uLCD_File_loadimagecontrol(char *datfile, char *gcifile, int mode);
    
int main()
{
  uLCD_Start(15, 14, 10, 115200);
  
  pause(1000);
  
  while(!uLCD_File_mount())
    pause(100);
    
  int handle = uLCD_File_loadimagecontrol("img.dat", "img.gci", 1);
  
  print("handle = %x\n", handle);
  pause(1000);
  
  int response = 0;
  response = uLCD_Img_show(handle, 0);
  print("response = %x\n", response);
  pause(1000);
  
  response = 0;
  response = uLCD_Img_show(handle, 1);
  print("response = %x\n", response);
  pause(1000);
  
  uLCD__Putstr("Hello uLCD!");
  pause(1000);
}

